<?php
/*
Plugin Name: Peter's Custom Anti-Spam
Plugin URI: http://www.theblog.ca/?p=21
Description: Stop a lot of spambots from polluting your site by making visitors identify a random word displayed as an image before commenting. You can customize the pool of words to display. This was originally based on Anti-Spam Image by Krazy Nio from http://www.infor96.com/~nio/archives/369
Author: Peter Keung
Version: 1.2
Author URI: http://www.theblog.ca
Change Log:
2006-06-24  The first version.
2006-07-05  Added the option to force registered users to enter the anti-spam word as well
2006-07-24  Based on a great mod by Lee Jordan (lee@leejordan.org.uk), which was in turn based on a php.net tutorial, allowing users who don't have imagettftext enabled to use custom words (just without a fancy font). He also developed a tweak to allow users the additional option of listening to an audio version of the anti-spam words (which you would record yourself) -- please contact him if you are interested in implementing this into your code.
2006-08-11  Slight tweak in the listing of words (no more counting needed).
2006-08-17  Added option to allow trackbacks (based on steveegg and Nio's fix).
2006-08-22  Fixed the if statement on trackbacks (thanks to TerminalDigit and Marc)
2006-08-30  More tweaking... to allow both trackbacks AND pingbacks
*/
// list your words

$text[] = "robin";
$text[] = "green";
$text[] = "smirk";
$text[] = "soft";
$text[] = "intro";
$text[] = "cracker";
$text[] = "hand";
$text[] = "hair";
$text[] = "daffodil";
$text[] = "fish";

// change this to equal 1 if you want to force registered users to enter the anti-spam word as well
$forcereg = 0;

// change this to equal 1 if you want to allow trackbacks and pingbacks (but be vulnerable to trackback spam)
$allowtrack = 0;

// begin all the code stuff

$textcount = count($text) - 1;

class AntiSpamImage {
    function AntiSpamImage()
    {
        add_action('comment_form', array(&$this, 'comment_form'));    //add image and input field to comment form
        add_action('comment_post', array(&$this, 'comment_post'));    //add post comment post security code check
    }

    function comment_form()
    {
        global $wpdb, $user_ID, $_SERVER, $forcereg, $textcount;

        // If the user is logged in, dont prompt for code
        if (isset($user_ID) && $forcereg == 0) {
            return $post_ID;
        }
// pick a random number
$antiselect = rand(0, $textcount);
        ?>
        <div style="display: left" id="secureimgdiv">
            <p>
            <input type="text" name="securitycode" id="securitycode" size="30" tabindex="4" />
            <input type="hidden" name="matchthis" value="<? echo $antiselect; ?>" />
            <label for="securitycode"><img src="<?php echo $_SERVER['PHP_SELF']; ?>?antiselect=<?php echo $antiselect; ?>" width="125" height="40" alt="Security Image" border="1" /> <small>Anti-spam word (required)</small></label>
            </p>
        </div>

        <script language="JavaScript" type="text/javascript">
            var urlinput = document.getElementById("url");
            var submitp = urlinput.parentNode;
            var substitution2 = document.getElementById("secureimgdiv");
            submitp.appendChild(substitution2, urlinput);
        </script>
        <?php
        return $post_ID;
    }

    function comment_post($post_ID)
    {
        global $wpdb, $user_ID, $_POST, $text, $forcereg, $allowtrack;

        $securitycode = strtolower($_POST['securitycode']);
        $matchthis = $text[$_POST['matchthis']];
        $istrackping = $wpdb->get_var("SELECT comment_type FROM {$wpdb->comments} WHERE comment_ID = {$post_ID}");
        // If the user is not logged in check the security code
        if (!isset($user_ID) or $forcereg == 1) {
        if ($istrackping == '' or $allowtrack == 0) {
            if ( '' == $securitycode ) {
                $this->comment_rollback($post_ID); //roll back
                die( __('Error: please enter the anti-spam word.') );
            }
            if ( $matchthis != $securitycode ) {
                $this->comment_rollback($post_ID); //roll back
                die( __('Please enter the correct anti-spam word. Press the back button and try again.') );
            } else {
                unset($matchthis);
            }
        }
        }
        return $post_ID;
    }

    function comment_rollback($post_ID)
    {
        global $wpdb, $wp_version;

        $pid = $wpdb->get_var("SELECT comment_post_ID FROM {$wpdb->comments} WHERE comment_ID = {$post_ID}");
        $wpdb->query("DELETE FROM {$wpdb->comments} WHERE comment_ID = {$post_ID}"); //roll back
        if ($wp_version >= '2.0') {
            $count = $wpdb->get_var("SELECT COUNT(*) FROM {$wpdb->comments} WHERE comment_post_ID = {$pid} AND comment_approved = '1'");
            $wpdb->query( "UPDATE {$wpdb->posts} SET comment_count = {$count} WHERE ID = {$pid}" );
        }
    }
}
// display an image

if (isset($_GET['antiselect'])) {
$antiselect = $_GET['antiselect'];
$antispam = $text[$antiselect];

// check for freetype lib, if not found default to ugly built in capability using imagechar (Lee's mod)
if(function_exists('imagettftext')) {
    header("Content-type: image/jpeg");

    $image = imagecreate(125,40);
    $white = imagecolorallocate($image, 255, 255, 255);
    $blue = imagecolorallocate($image, 0, 0, 255);
    imagettftext($image, 28, 5, 10, 30, $blue, "jenkinsv", $antispam);
    imagejpeg($image);
    imagedestroy ($image);

} else {
    $string = $antispam;
    $font_size = 7;
    $width=imagefontwidth($font_size)*strlen($string);
    $height=imagefontheight($font_size)*2;
    $img = imagecreate(125,40);
    $bg = imagecolorallocate($img,255,255,255);
    $fontcolor = imagecolorallocate($img,0,0,255);
    $len=strlen($string);
    
    for($i=0;$i<$len;$i++)
    {
       $xpos=$i*imagefontwidth($font_size)+20;
       $ypos=10;
       imagechar($img,$font_size,$xpos,$ypos,$string,$fontcolor);
       $string = substr($string,1);   
      
    }
    header("Content-Type: image/gif");
    imagegif($img);
    imagedestroy($img);
} // end if


}
else {
new AntiSpamImage();
}
?>